//--------------------------------------------------------------//
// AlphaKey
//
// Copyright (c) EditShare EMEA.  All Rights Reserved
//--------------------------------------------------------------//

int _LwksEffectInfo
<
   string EffectGroup = "GenericPixelShader";
   string Description = "Alphakey";
   string Category    = "Keying";
> = 0;

//--------------------------------------------------------------//
// Inputs
//--------------------------------------------------------------//
texture fg;
texture bg;

//--------------------------------------------------------------//
// Samplers
//--------------------------------------------------------------//
sampler FgSampler = sampler_state { Texture = <fg>; };
sampler BgSampler = sampler_state { Texture = <bg>; };

//--------------------------------------------------------------//
// Pixel Shader
//--------------------------------------------------------------//
float4 ps_main( float2 texCoord : TEXCOORD0 ) : COLOR
{
   float4 fgPix = tex2D( FgSampler, texCoord );
   float4 bgPix = tex2D( BgSampler, texCoord );
   float4 ret = float4( fgPix.a * fgPix ) + ( ( 1.0 - fgPix.a ) * bgPix );
   ret.a = 1.0;

   return ret;
}

//--------------------------------------------------------------//
// Techniques
//--------------------------------------------------------------//
technique AlphaKey
{
   pass Single_Pass
   {
      PixelShader = compile PROFILE ps_main();
   }
}

