//--------------------------------------------------------------//
// Channel Offset
//
// Copyright (c) EditShare EMEA.  All Rights Reserved
//--------------------------------------------------------------//

int _LwksEffectInfo
<
   string EffectGroup = "GenericPixelShader";
   string Description = "Channel Offset";
   string Category    = "Stylize";
> = 0;

//--------------------------------------------------------------//
// Params
//--------------------------------------------------------------//
float RedX
<
   string Description = "Red";
   string Flags = "SpecifiesPointX";
   float MinVal = -1.0;
   float MaxVal = 1.0;
> = 0.0;

float RedY
<
   string Description = "Red";
   string Flags = "SpecifiesPointY";
   float MinVal = -1.0;
   float MaxVal = 1.0;
> = 0.0;

float GreenX
<
   string Description = "Green";
   string Flags = "SpecifiesPointX";
   float MinVal = -1.0;
   float MaxVal = 1.0;
> = 0.0;

float GreenY
<
   string Description = "Green";
   string Flags = "SpecifiesPointY";
   float MinVal = -1.0;
   float MaxVal = 1.0;
> = 0.0;

float BlueX
<
   string Description = "Blue";
   string Flags = "SpecifiesPointX";
   float MinVal = -1.0;
   float MaxVal = 1.0;
> = 0.0;

float BlueY
<
   string Description = "Blue";
   string Flags = "SpecifiesPointY";
   float MinVal = -1.0;
   float MaxVal = 1.0;
> = 0.0;

const float _maxShift = 0.1;

//--------------------------------------------------------------//
// Inputs
//--------------------------------------------------------------//
texture Input;
sampler InputSampler = sampler_state { Texture = <Input>; };

//--------------------------------------------------------------//
// Code
//--------------------------------------------------------------//
float4 ps_main( float2 xy1 : TEXCOORD1 ) : COLOR
{
   float4 pixel  = tex2D( InputSampler, xy1 );
   float4 RPixel = tex2D( InputSampler, xy1 + ( float2( -RedX,   RedY ) * _maxShift ) );
   float4 GPixel = tex2D( InputSampler, xy1 + ( float2( -GreenX, GreenY ) * _maxShift ) );
   float4 BPixel = tex2D( InputSampler, xy1 + ( float2( -BlueX,  BlueY ) * _maxShift ) );

   return float4( RPixel.r, GPixel.g, BPixel.b, pixel.a );
}

//--------------------------------------------------------------//
// Technique Section for Image Processing Effects
//--------------------------------------------------------------//
technique ChannelOffset { pass Single_Pass { PixelShader = compile PROFILE ps_main(); } }
