//--------------------------------------------------------------//
// Flat Colour Effects
//
// Copyright (c) EditShare EMEA.  All Rights Reserved
//--------------------------------------------------------------//

int _LwksEffectInfo
<
   string EffectGroup = "GenericPixelShader";
   string Description = "Colour Matte";
   string Category    = "Mattes";
> = 0;

//--------------------------------------------------------------//
// Params
//--------------------------------------------------------------//

float4 Colour
<
   string Description = "Colour";
> = { 1.0, 1.0, 1.0, 1.0 };

texture Input;
sampler2D InputSampler = sampler_state { Texture = <Input>; };


//--------------------------------------------------------------//
// Code
//--------------------------------------------------------------//
float4 ps_main( float2 xy : TEXCOORD1 ) : COLOR
{
   float4 bg = tex2D( InputSampler, xy );
   float4 ret = lerp( tex2D( InputSampler, xy ), Colour, Colour.a );
   ret.a = bg.a;

   return ret;
}

//--------------------------------------------------------------//
// Technique Section for Image Processing Effects
//--------------------------------------------------------------//
technique FlatColour { pass Single_Pass { PixelShader = compile PROFILE ps_main(); } }
