//--------------------------------------------------------------//
// Mix
//
// Copyright (c) EditShare EMEA.  All Rights Reserved
//--------------------------------------------------------------//

int _LwksEffectInfo
<
   string EffectGroup = "GenericPixelShader";
   string Description = "Dissolve";
   string Category    = "Mixes";
> = 0;

//--------------------------------------------------------------//
// Params
//--------------------------------------------------------------//
float Amount
<
   string Description = "Amount";
   float MinVal = 0.0;
   float MaxVal = 1.0;
   float KF0    = 0.0;
   float KF1    = 1.0;
> = 0.5;

//--------------------------------------------------------------//
// Inputs
//--------------------------------------------------------------//
texture fg;
texture bg;

//--------------------------------------------------------------//
// Samplers
//--------------------------------------------------------------//
sampler FgSampler = sampler_state { Texture = <fg>; };
sampler BgSampler = sampler_state { Texture = <bg>; };

//--------------------------------------------------------------//
// Pixel Shader
//--------------------------------------------------------------//
float4 ps_main( float2 xy1 : TEXCOORD1, float2 xy2 : TEXCOORD2 ) : COLOR
{
   float4 fgPix = tex2D( FgSampler, xy1 );
   float4 bgPix = tex2D( BgSampler, xy2 );

   return lerp( fgPix, bgPix, Amount );
}

//--------------------------------------------------------------//
// Techniques
//--------------------------------------------------------------//
technique Dissolve { pass Single_Pass { PixelShader = compile PROFILE ps_main(); } }
