//--------------------------------------------------------------//
// Mosaic
//
// Copyright (c) EditShare EMEA.  All Rights Reserved
//--------------------------------------------------------------//

int _LwksEffectInfo
<
   string EffectGroup = "GenericPixelShader";
   string Description = "Mosaic";
   string Category    = "Stylize";
> = 0;

//--------------------------------------------------------------//
// Params
//--------------------------------------------------------------//
float Size
<
   string Description = "Size";
   float MinVal = 0.00;
   float MaxVal = 1.00;
> = 0.01;

float _OutputAspectRatio;

//--------------------------------------------------------------//
// Inputs
//--------------------------------------------------------------//
texture Input;
sampler2D InputSampler = sampler_state { Texture = <Input>; };

//--------------------------------------------------------------//
// Code
//--------------------------------------------------------------//
float4 ps_main( float2 xy1 : TEXCOORD1 ) : COLOR
{
   float4 ret;

   float4 source = tex2D( InputSampler, xy1 );

   if ( Size != 0.0 )
   {
      float xSize = Size;
      float ySize = xSize * _OutputAspectRatio;

      ret = tex2D( InputSampler,
                   float2( round( ( xy1.x - 0.5 ) / xSize ) * xSize,
                           round( ( xy1.y - 0.5 ) / ySize ) * ySize ) + 0.5 );

      ret = lerp( source, ret, source.a );
   }
   else
      ret = source;

   return ret;
}

technique Mosaic { pass Single_Pass { PixelShader = compile PROFILE ps_main(); } }
