//--------------------------------------------------------------//
// Posterize
//
// Copyright (c) EditShare EMEA.  All Rights Reserved
//--------------------------------------------------------------//

int _LwksEffectInfo
<
   string EffectGroup = "GenericPixelShader";
   string Description = "Posterize";
   string Category    = "Stylize";
> = 0;

//--------------------------------------------------------------//
// Params
//--------------------------------------------------------------//
float Amount
<
   string Description = "Amount";
   float MinVal = 0.00;
   float MaxVal = 1.00;
> = 0.16 ;

//--------------------------------------------------------------//
// Inputs
//--------------------------------------------------------------//
texture Input;
sampler InputSampler = sampler_state { Texture = <Input>; };

//--------------------------------------------------------------//
// Code
//--------------------------------------------------------------//
float4 ps_main( float2 xy1 : TEXCOORD1 ) : COLOR
{
   float4 source = tex2D( InputSampler, xy1 );
   float4 ret = source;

   int granularity   = Amount * 255.0;

   if ( granularity == 0 )
   {
      granularity = 1;
   }

   ret *= 255.0;

   ret = float4( ( int )( ret.r / granularity ),
                 ( int )( ret.g / granularity ),
                 ( int )( ret.b / granularity ),
                 255.0 );

   ret = ( ( ret * granularity ) + ( granularity / 2 ) ) / 255.0;
   ret = lerp( source, ret, source.a );

   return ret;
}

technique Posterize { pass Single_Pass { PixelShader = compile PROFILE ps_main(); } }
