//--------------------------------------------------------------//
// Radial Blur
//
// Copyright (c) EditShare EMEA.  All Rights Reserved
//--------------------------------------------------------------//

int _LwksEffectInfo
<
   string EffectGroup = "GenericPixelShader";
   string Description = "Radial Blur";
   string Category    = "Stylize";
> = 0;

//--------------------------------------------------------------//
// Params
//--------------------------------------------------------------//

float CentreX
<
   string Description = "Origin";
   string Flags = "SpecifiesPointX";
   float MinVal = 0.00;
   float MaxVal = 1.00;
> = 0.5;

float CentreY
<
   string Description = "Origin";
   string Flags = "SpecifiesPointY";
   float MinVal = 0.00;
   float MaxVal = 1.00;
> = 0.5;

//--------------------------------------------------------------//
// Inputs
//--------------------------------------------------------------//
texture Input;
sampler InputSampler = sampler_state
{
   Texture = <Input>;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
   MAGFILTER = LINEAR;
};

//--------------------------------------------------------------//
// Code
//--------------------------------------------------------------//
float _OutputWidth;//  = 1.0;
float _OutputHeight;// = 1.0;

float4 ps_main( float2 xy1 : TEXCOORD1 ) : COLOR
{
   float4 ret;
   float2 amount = float2( 3 / _OutputWidth, 3 / _OutputHeight );

   float centreY = 1.0 - CentreY;

   float x = xy1.x - CentreX;
   float y = xy1.y - centreY;

   float2 adj = 1.0 - amount;

   ret = tex2D( InputSampler, float2( x * adj.x + CentreX, y * adj.y + centreY ) );

   adj -= amount;
   ret += tex2D( InputSampler, float2( x * adj.x + CentreX, y * adj.y + centreY ) );

   adj -= amount;
   ret += tex2D( InputSampler, float2( x * adj.x + CentreX, y * adj.y + centreY ) );

   adj -= amount;
   ret += tex2D( InputSampler, float2( x * adj.x + CentreX, y * adj.y + centreY ) );

   adj -= amount;
   ret += tex2D( InputSampler, float2( x * adj.x + CentreX, y * adj.y + centreY ) );

   adj -= amount;
   ret += tex2D( InputSampler, float2( x * adj.x + CentreX, y * adj.y + centreY ) );

   adj -= amount;
   ret += tex2D( InputSampler, float2( x * adj.x + CentreX, y * adj.y + centreY ) );

   adj -= amount;
   ret += tex2D( InputSampler, float2( x * adj.x + CentreX, y * adj.y + centreY ) );

   adj -= amount;
   ret += tex2D( InputSampler, float2( x * adj.x + CentreX, y * adj.y + centreY ) );

   float4 source = tex2D( InputSampler, xy1 );
   ret = lerp( source, ret / 10, source.a );

   return ret;
}

technique Blur { pass Single_Pass { PixelShader = compile PROFILE ps_main(); } }
